import { useState } from 'react';
import { Platform } from 'react-native';
import { checkMultiple, requestMultiple, RESULTS, } from 'react-native-permissions';
import { useShow, useHide } from 'react-native-lifecycle';
export default (permissions, permissionStatus = RESULTS.GRANTED) => {
    const [state, setState] = useState(null);
    if (typeof permissions === 'string') {
        permissions = [permissions];
    }
    permissions = permissions.filter((item) => item && item.startsWith(Platform.OS));
    useShow(() => {
        checkMultiple(permissions).then((states) => {
            setState(permissions.every((permission) => states[permission] === permissionStatus));
        });
    });
    useHide(() => {
        setState(null);
    });
    const request = () => {
        return new Promise((resolve, reject) => {
            requestMultiple(permissions).then((states) => {
                if (permissions.every((permission) => states[permission] === permissionStatus)) {
                    resolve();
                }
                else {
                    reject();
                }
            });
        });
    };
    return {
        state,
        request,
    };
};
